net.sf.cpsolver.coursett.criteria

## Class RoomViolations

- java.lang.Object
- - net.sf.cpsolver.ifs.criteria.AbstractCriterion<Lecture,Placement>
  - - net.sf.cpsolver.coursett.criteria.TimetablingCriterion
    - - net.sf.cpsolver.coursett.criteria.RoomViolations

- All Implemented Interfaces:
    Criterion<Lecture,Placement>, InfoProvider<Lecture>, ModelListener<Lecture,Placement>
  Direct Known Subclasses:
    TimeViolations

      public class RoomViolations
      extends TimetablingCriterion

  Room violations. This criterion counts how many times a prohibited room is assigned to a class in interactive timetabling.
  Version:
    CourseTT 1.2 (University Course Timetabling)
    Copyright (C) 2006 - 2011 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.sf.cpsolver.ifs.criteria.AbstractCriterion

      `AbstractCriterion.ValueUpdateType`

  - ### Field Summary

    - ### Fields inherited from class net.sf.cpsolver.ifs.criteria.AbstractCriterion

      `iBest, iDebug, iValue, iValueUpdateType, iWeight, sDoubleFormat, sPercentFormat`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RoomViolations()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `double[]` | `getBounds()` Bounds (minimum and maximum) estimate for the value
    `double[]` | `getBounds(Collection<Lecture> variables)` Value bounds (minimum and maximum) of the criterion on a part of the problem
    `double` | `getValue(Placement value, Set<Placement> conflicts)` Value of a proposed assignment (including hard conflicts)
    `protected boolean` | `violation(Placement value)`

    - ### Methods inherited from class net.sf.cpsolver.coursett.criteria.TimetablingCriterion

      `getAbbreviation, getPlacementSelectionWeight, getPlacementSelectionWeightDefault, getPlacementSelectionWeightName, init, toString`

    - ### Methods inherited from class net.sf.cpsolver.ifs.criteria.AbstractCriterion

      `afterAssigned, afterUnassigned, beforeAssigned, beforeUnassigned, bestRestored, bestSaved, clearCache, computeBounds, constraintAdded, constraintRemoved, getBest, getInfo, getInfo, getModel, getName, getPerc, getPercRev, getValue, getValue, getWeight, getWeightDefault, getWeightedBest, getWeightedValue, getWeightedValue, getWeightedValue, getWeightName, inc, variableAdded, variableRemoved`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### RoomViolations

          public RoomViolations()

  - ### Method Detail

    - #### violation

          protected boolean violation(Placement value)

    - #### getValue

          public double getValue(Placement value,
                                 Set<Placement> conflicts)

      Description copied from interface: `Criterion`
      Value of a proposed assignment (including hard conflicts)

    - #### getBounds

          public double[] getBounds()

      Description copied from interface: `Criterion`
      Bounds (minimum and maximum) estimate for the value
      Specified by:
        `getBounds` in interface `Criterion<Lecture,Placement>`
      Overrides:
        `getBounds` in class `AbstractCriterion<Lecture,Placement>`

    - #### getBounds

          public double[] getBounds(Collection<Lecture> variables)

      Description copied from interface: `Criterion`
      Value bounds (minimum and maximum) of the criterion on a part of the problem
      Specified by:
        `getBounds` in interface `Criterion<Lecture,Placement>`
      Overrides:
        `getBounds` in class `AbstractCriterion<Lecture,Placement>`